--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/data/proc_writes.xregs.zmm.64	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,136 @@
+zmm[00] [03:00] = { 0xfaceecb2 0xfaceecb1 0xfaceecb0 0xfaceecaf }
+zmm[00] [07:04] = { 0xfaceecb6 0xfaceecb5 0xfaceecb4 0xfaceecb3 }
+zmm[00] [11:08] = { 0xfaceecba 0xfaceecb9 0xfaceecb8 0xfaceecb7 }
+zmm[00] [15:12] = { 0xfaceecbe 0xfaceecbd 0xfaceecbc 0xfaceecbb }
+zmm[01] [03:00] = { 0xfaceecc2 0xfaceecc1 0xfaceecc0 0xfaceecbf }
+zmm[01] [07:04] = { 0xfaceecc6 0xfaceecc5 0xfaceecc4 0xfaceecc3 }
+zmm[01] [11:08] = { 0xfaceecca 0xfaceecc9 0xfaceecc8 0xfaceecc7 }
+zmm[01] [15:12] = { 0xfaceecce 0xfaceeccd 0xfaceeccc 0xfaceeccb }
+zmm[02] [03:00] = { 0xfaceecd2 0xfaceecd1 0xfaceecd0 0xfaceeccf }
+zmm[02] [07:04] = { 0xfaceecd6 0xfaceecd5 0xfaceecd4 0xfaceecd3 }
+zmm[02] [11:08] = { 0xfaceecda 0xfaceecd9 0xfaceecd8 0xfaceecd7 }
+zmm[02] [15:12] = { 0xfaceecde 0xfaceecdd 0xfaceecdc 0xfaceecdb }
+zmm[03] [03:00] = { 0xfaceece2 0xfaceece1 0xfaceece0 0xfaceecdf }
+zmm[03] [07:04] = { 0xfaceece6 0xfaceece5 0xfaceece4 0xfaceece3 }
+zmm[03] [11:08] = { 0xfaceecea 0xfaceece9 0xfaceece8 0xfaceece7 }
+zmm[03] [15:12] = { 0xfaceecee 0xfaceeced 0xfaceecec 0xfaceeceb }
+zmm[04] [03:00] = { 0xfaceecf2 0xfaceecf1 0xfaceecf0 0xfaceecef }
+zmm[04] [07:04] = { 0xfaceecf6 0xfaceecf5 0xfaceecf4 0xfaceecf3 }
+zmm[04] [11:08] = { 0xfaceecfa 0xfaceecf9 0xfaceecf8 0xfaceecf7 }
+zmm[04] [15:12] = { 0xfaceecfe 0xfaceecfd 0xfaceecfc 0xfaceecfb }
+zmm[05] [03:00] = { 0xfaceed02 0xfaceed01 0xfaceed00 0xfaceecff }
+zmm[05] [07:04] = { 0xfaceed06 0xfaceed05 0xfaceed04 0xfaceed03 }
+zmm[05] [11:08] = { 0xfaceed0a 0xfaceed09 0xfaceed08 0xfaceed07 }
+zmm[05] [15:12] = { 0xfaceed0e 0xfaceed0d 0xfaceed0c 0xfaceed0b }
+zmm[06] [03:00] = { 0xfaceed12 0xfaceed11 0xfaceed10 0xfaceed0f }
+zmm[06] [07:04] = { 0xfaceed16 0xfaceed15 0xfaceed14 0xfaceed13 }
+zmm[06] [11:08] = { 0xfaceed1a 0xfaceed19 0xfaceed18 0xfaceed17 }
+zmm[06] [15:12] = { 0xfaceed1e 0xfaceed1d 0xfaceed1c 0xfaceed1b }
+zmm[07] [03:00] = { 0xfaceed22 0xfaceed21 0xfaceed20 0xfaceed1f }
+zmm[07] [07:04] = { 0xfaceed26 0xfaceed25 0xfaceed24 0xfaceed23 }
+zmm[07] [11:08] = { 0xfaceed2a 0xfaceed29 0xfaceed28 0xfaceed27 }
+zmm[07] [15:12] = { 0xfaceed2e 0xfaceed2d 0xfaceed2c 0xfaceed2b }
+zmm[08] [03:00] = { 0xfaceed32 0xfaceed31 0xfaceed30 0xfaceed2f }
+zmm[08] [07:04] = { 0xfaceed36 0xfaceed35 0xfaceed34 0xfaceed33 }
+zmm[08] [11:08] = { 0xfaceed3a 0xfaceed39 0xfaceed38 0xfaceed37 }
+zmm[08] [15:12] = { 0xfaceed3e 0xfaceed3d 0xfaceed3c 0xfaceed3b }
+zmm[09] [03:00] = { 0xfaceed42 0xfaceed41 0xfaceed40 0xfaceed3f }
+zmm[09] [07:04] = { 0xfaceed46 0xfaceed45 0xfaceed44 0xfaceed43 }
+zmm[09] [11:08] = { 0xfaceed4a 0xfaceed49 0xfaceed48 0xfaceed47 }
+zmm[09] [15:12] = { 0xfaceed4e 0xfaceed4d 0xfaceed4c 0xfaceed4b }
+zmm[10] [03:00] = { 0xfaceed52 0xfaceed51 0xfaceed50 0xfaceed4f }
+zmm[10] [07:04] = { 0xfaceed56 0xfaceed55 0xfaceed54 0xfaceed53 }
+zmm[10] [11:08] = { 0xfaceed5a 0xfaceed59 0xfaceed58 0xfaceed57 }
+zmm[10] [15:12] = { 0xfaceed5e 0xfaceed5d 0xfaceed5c 0xfaceed5b }
+zmm[11] [03:00] = { 0xfaceed62 0xfaceed61 0xfaceed60 0xfaceed5f }
+zmm[11] [07:04] = { 0xfaceed66 0xfaceed65 0xfaceed64 0xfaceed63 }
+zmm[11] [11:08] = { 0xfaceed6a 0xfaceed69 0xfaceed68 0xfaceed67 }
+zmm[11] [15:12] = { 0xfaceed6e 0xfaceed6d 0xfaceed6c 0xfaceed6b }
+zmm[12] [03:00] = { 0xfaceed72 0xfaceed71 0xfaceed70 0xfaceed6f }
+zmm[12] [07:04] = { 0xfaceed76 0xfaceed75 0xfaceed74 0xfaceed73 }
+zmm[12] [11:08] = { 0xfaceed7a 0xfaceed79 0xfaceed78 0xfaceed77 }
+zmm[12] [15:12] = { 0xfaceed7e 0xfaceed7d 0xfaceed7c 0xfaceed7b }
+zmm[13] [03:00] = { 0xfaceed82 0xfaceed81 0xfaceed80 0xfaceed7f }
+zmm[13] [07:04] = { 0xfaceed86 0xfaceed85 0xfaceed84 0xfaceed83 }
+zmm[13] [11:08] = { 0xfaceed8a 0xfaceed89 0xfaceed88 0xfaceed87 }
+zmm[13] [15:12] = { 0xfaceed8e 0xfaceed8d 0xfaceed8c 0xfaceed8b }
+zmm[14] [03:00] = { 0xfaceed92 0xfaceed91 0xfaceed90 0xfaceed8f }
+zmm[14] [07:04] = { 0xfaceed96 0xfaceed95 0xfaceed94 0xfaceed93 }
+zmm[14] [11:08] = { 0xfaceed9a 0xfaceed99 0xfaceed98 0xfaceed97 }
+zmm[14] [15:12] = { 0xfaceed9e 0xfaceed9d 0xfaceed9c 0xfaceed9b }
+zmm[15] [03:00] = { 0xfaceeda2 0xfaceeda1 0xfaceeda0 0xfaceed9f }
+zmm[15] [07:04] = { 0xfaceeda6 0xfaceeda5 0xfaceeda4 0xfaceeda3 }
+zmm[15] [11:08] = { 0xfaceedaa 0xfaceeda9 0xfaceeda8 0xfaceeda7 }
+zmm[15] [15:12] = { 0xfaceedae 0xfaceedad 0xfaceedac 0xfaceedab }
+zmm[16] [03:00] = { 0xfaceedb2 0xfaceedb1 0xfaceedb0 0xfaceedaf }
+zmm[16] [07:04] = { 0xfaceedb6 0xfaceedb5 0xfaceedb4 0xfaceedb3 }
+zmm[16] [11:08] = { 0xfaceedba 0xfaceedb9 0xfaceedb8 0xfaceedb7 }
+zmm[16] [15:12] = { 0xfaceedbe 0xfaceedbd 0xfaceedbc 0xfaceedbb }
+zmm[17] [03:00] = { 0xfaceedc2 0xfaceedc1 0xfaceedc0 0xfaceedbf }
+zmm[17] [07:04] = { 0xfaceedc6 0xfaceedc5 0xfaceedc4 0xfaceedc3 }
+zmm[17] [11:08] = { 0xfaceedca 0xfaceedc9 0xfaceedc8 0xfaceedc7 }
+zmm[17] [15:12] = { 0xfaceedce 0xfaceedcd 0xfaceedcc 0xfaceedcb }
+zmm[18] [03:00] = { 0xfaceedd2 0xfaceedd1 0xfaceedd0 0xfaceedcf }
+zmm[18] [07:04] = { 0xfaceedd6 0xfaceedd5 0xfaceedd4 0xfaceedd3 }
+zmm[18] [11:08] = { 0xfaceedda 0xfaceedd9 0xfaceedd8 0xfaceedd7 }
+zmm[18] [15:12] = { 0xfaceedde 0xfaceeddd 0xfaceeddc 0xfaceeddb }
+zmm[19] [03:00] = { 0xfaceede2 0xfaceede1 0xfaceede0 0xfaceeddf }
+zmm[19] [07:04] = { 0xfaceede6 0xfaceede5 0xfaceede4 0xfaceede3 }
+zmm[19] [11:08] = { 0xfaceedea 0xfaceede9 0xfaceede8 0xfaceede7 }
+zmm[19] [15:12] = { 0xfaceedee 0xfaceeded 0xfaceedec 0xfaceedeb }
+zmm[20] [03:00] = { 0xfaceedf2 0xfaceedf1 0xfaceedf0 0xfaceedef }
+zmm[20] [07:04] = { 0xfaceedf6 0xfaceedf5 0xfaceedf4 0xfaceedf3 }
+zmm[20] [11:08] = { 0xfaceedfa 0xfaceedf9 0xfaceedf8 0xfaceedf7 }
+zmm[20] [15:12] = { 0xfaceedfe 0xfaceedfd 0xfaceedfc 0xfaceedfb }
+zmm[21] [03:00] = { 0xfaceee02 0xfaceee01 0xfaceee00 0xfaceedff }
+zmm[21] [07:04] = { 0xfaceee06 0xfaceee05 0xfaceee04 0xfaceee03 }
+zmm[21] [11:08] = { 0xfaceee0a 0xfaceee09 0xfaceee08 0xfaceee07 }
+zmm[21] [15:12] = { 0xfaceee0e 0xfaceee0d 0xfaceee0c 0xfaceee0b }
+zmm[22] [03:00] = { 0xfaceee12 0xfaceee11 0xfaceee10 0xfaceee0f }
+zmm[22] [07:04] = { 0xfaceee16 0xfaceee15 0xfaceee14 0xfaceee13 }
+zmm[22] [11:08] = { 0xfaceee1a 0xfaceee19 0xfaceee18 0xfaceee17 }
+zmm[22] [15:12] = { 0xfaceee1e 0xfaceee1d 0xfaceee1c 0xfaceee1b }
+zmm[23] [03:00] = { 0xfaceee22 0xfaceee21 0xfaceee20 0xfaceee1f }
+zmm[23] [07:04] = { 0xfaceee26 0xfaceee25 0xfaceee24 0xfaceee23 }
+zmm[23] [11:08] = { 0xfaceee2a 0xfaceee29 0xfaceee28 0xfaceee27 }
+zmm[23] [15:12] = { 0xfaceee2e 0xfaceee2d 0xfaceee2c 0xfaceee2b }
+zmm[24] [03:00] = { 0xfaceee32 0xfaceee31 0xfaceee30 0xfaceee2f }
+zmm[24] [07:04] = { 0xfaceee36 0xfaceee35 0xfaceee34 0xfaceee33 }
+zmm[24] [11:08] = { 0xfaceee3a 0xfaceee39 0xfaceee38 0xfaceee37 }
+zmm[24] [15:12] = { 0xfaceee3e 0xfaceee3d 0xfaceee3c 0xfaceee3b }
+zmm[25] [03:00] = { 0xfaceee42 0xfaceee41 0xfaceee40 0xfaceee3f }
+zmm[25] [07:04] = { 0xfaceee46 0xfaceee45 0xfaceee44 0xfaceee43 }
+zmm[25] [11:08] = { 0xfaceee4a 0xfaceee49 0xfaceee48 0xfaceee47 }
+zmm[25] [15:12] = { 0xfaceee4e 0xfaceee4d 0xfaceee4c 0xfaceee4b }
+zmm[26] [03:00] = { 0xfaceee52 0xfaceee51 0xfaceee50 0xfaceee4f }
+zmm[26] [07:04] = { 0xfaceee56 0xfaceee55 0xfaceee54 0xfaceee53 }
+zmm[26] [11:08] = { 0xfaceee5a 0xfaceee59 0xfaceee58 0xfaceee57 }
+zmm[26] [15:12] = { 0xfaceee5e 0xfaceee5d 0xfaceee5c 0xfaceee5b }
+zmm[27] [03:00] = { 0xfaceee62 0xfaceee61 0xfaceee60 0xfaceee5f }
+zmm[27] [07:04] = { 0xfaceee66 0xfaceee65 0xfaceee64 0xfaceee63 }
+zmm[27] [11:08] = { 0xfaceee6a 0xfaceee69 0xfaceee68 0xfaceee67 }
+zmm[27] [15:12] = { 0xfaceee6e 0xfaceee6d 0xfaceee6c 0xfaceee6b }
+zmm[28] [03:00] = { 0xfaceee72 0xfaceee71 0xfaceee70 0xfaceee6f }
+zmm[28] [07:04] = { 0xfaceee76 0xfaceee75 0xfaceee74 0xfaceee73 }
+zmm[28] [11:08] = { 0xfaceee7a 0xfaceee79 0xfaceee78 0xfaceee77 }
+zmm[28] [15:12] = { 0xfaceee7e 0xfaceee7d 0xfaceee7c 0xfaceee7b }
+zmm[29] [03:00] = { 0xfaceee82 0xfaceee81 0xfaceee80 0xfaceee7f }
+zmm[29] [07:04] = { 0xfaceee86 0xfaceee85 0xfaceee84 0xfaceee83 }
+zmm[29] [11:08] = { 0xfaceee8a 0xfaceee89 0xfaceee88 0xfaceee87 }
+zmm[29] [15:12] = { 0xfaceee8e 0xfaceee8d 0xfaceee8c 0xfaceee8b }
+zmm[30] [03:00] = { 0xfaceee92 0xfaceee91 0xfaceee90 0xfaceee8f }
+zmm[30] [07:04] = { 0xfaceee96 0xfaceee95 0xfaceee94 0xfaceee93 }
+zmm[30] [11:08] = { 0xfaceee9a 0xfaceee99 0xfaceee98 0xfaceee97 }
+zmm[30] [15:12] = { 0xfaceee9e 0xfaceee9d 0xfaceee9c 0xfaceee9b }
+zmm[31] [03:00] = { 0xfaceeea2 0xfaceeea1 0xfaceeea0 0xfaceee9f }
+zmm[31] [07:04] = { 0xfaceeea6 0xfaceeea5 0xfaceeea4 0xfaceeea3 }
+zmm[31] [11:08] = { 0xfaceeeaa 0xfaceeea9 0xfaceeea8 0xfaceeea7 }
+zmm[31] [15:12] = { 0xfaceeeae 0xfaceeead 0xfaceeeac 0xfaceeeab }
+%k0 0xfaceeeb0faceeeaf
+%k1 0xfaceeeb2faceeeb1
+%k2 0xfaceeeb4faceeeb3
+%k3 0xfaceeeb6faceeeb5
+%k4 0xfaceeeb8faceeeb7
+%k5 0xfaceeebafaceeeb9
+%k6 0xfaceeebcfaceeebb
+%k7 0xfaceeebefaceeebd
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/fpregs.c	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,130 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * This test verifies the following:
+ *
+ *   o xregs and fpregs report the same content for the xmm registers at least.
+ *   o A write to xregs is reflected in reads of fpregs.
+ *   o A write to the fpregs is reflected in reads of xregs and doesn't
+ *     clobber additional state in xregs.
+ *   o A thread in our victim process sees the final state here and can print
+ *     that out.
+ *   o As a side effect it makes sure that libproc isn't incorrectly caching
+ *     register info on handles.
+ *
+ * We use the xsu_dump process of the same bitness as us.
+ */
+
+#include <err.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <string.h>
+
+#include "xsave_util.h"
+
+static xsu_fpu_t fpu;
+
+int
+main(int argc, char *argv[])
+{
+	uint32_t seed, hwsup;
+	unsigned long ul;
+	char *eptr;
+	prxregset_t *prx, *cmp_prx;
+	size_t prx_len, cmp_prx_len;
+	xsu_proc_t xp;
+	fpregset_t fpr;
+
+	if (argc != 5) {
+		errx(EXIT_FAILURE, "missing args: <prog> <output file> "
+		    "<seed> <func>");
+	}
+
+	errno = 0;
+	ul = strtoul(argv[3], &eptr, 0);
+	if (errno != 0 || *eptr != '\0') {
+		errx(EXIT_FAILURE, "seed value is bad: %s", argv[3]);
+	}
+
+#if defined(_LP64)
+	if (ul > UINT32_MAX) {
+		errx(EXIT_FAILURE, "seed %s, exceeds [0, UINT32_MAX]", argv[3]);
+	}
+#endif
+
+	seed = (uint32_t)ul;
+	hwsup = xsu_hwsupport();
+	xsu_fill(&fpu, hwsup, seed);
+	xsu_fpu_to_xregs(&fpu, hwsup, &prx, &prx_len);
+
+	(void) memset(&xp, 0, sizeof (xsu_proc_t));
+	xp.xp_prog = argv[1];
+	xp.xp_arg = argv[2];
+	xp.xp_object = "a.out";
+	xp.xp_symname = argv[4];
+	xsu_proc_bkpt(&xp);
+
+	/*
+	 * First get the xregs into a reasonable place.
+	 */
+	if (Plwp_setxregs(xp.xp_proc, 1, prx, prx_len) != 0) {
+		err(EXIT_FAILURE, "failed to set target's xregs");
+	}
+
+	/*
+	 * Now that we have that, let's go and get the fpregs. Because of
+	 * differences between the 32-bit representation and the xsave state in
+	 * the xregs, we stick to different checking in an ILP32 vs. LP64 pieces
+	 * of this.
+	 */
+	if (Plwp_getfpregs(xp.xp_proc, 1, &fpr) != 0) {
+		err(EXIT_FAILURE, "failed to get the fp registers");
+	}
+
+	if (!xsu_fpregs_cmp(&fpr, prx)) {
+		errx(EXIT_FAILURE, "fpregs do not reflect xsave changes!");
+	}
+	(void) printf("TEST PASSED: fpregs read respects xregs write\n");
+
+	/*
+	 * Override the xmm registers with the known variant of the seed and set
+	 * that. Update the xregs data so we can later compare them usefully.
+	 */
+	xsu_fpregset_xmm_set(&fpr, seed + INT32_MAX);
+	xsu_xregs_xmm_set(prx, seed + INT32_MAX);
+	if (Plwp_setfpregs(xp.xp_proc, 1, &fpr) != 0) {
+		err(EXIT_FAILURE, "failed to set fpregs");
+	}
+
+	if (Plwp_getxregs(xp.xp_proc, 1, &cmp_prx, &cmp_prx_len) != 0) {
+		err(EXIT_FAILURE, "failed to get comparison xregs");
+	}
+
+	if (!xsu_fpregs_cmp(&fpr, cmp_prx)) {
+		errx(EXIT_FAILURE, "fpregs do not reflect xsave changes!");
+	}
+	(void) printf("TEST PASSED: xregs read respects fpregs write\n");
+
+	if (!xsu_xregs_comp_equal(prx, cmp_prx, PRX_INFO_YMM)) {
+		errx(EXIT_FAILURE, "%%ymm state changed across fpregs write");
+	}
+	(void) printf("TEST PASSED: fpregs did not change other xregs "
+	    "components\n");
+
+	xsu_proc_finish(&xp);
+
+	return (EXIT_SUCCESS);
+}
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/fpregs_xbv.c	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,81 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * In illumos#15367 we noted that on some CPUs it was possible to get the xsave
+ * state into a place where it has not set components that are used for the x87
+ * and XMM state. This test attempts to create those situations and then get a
+ * ucontext_t to see that we actually have cleared it out. Because this behavior
+ * varies from CPU to CPU (e.g. in the original case we only saw this on AMD and
+ * not Intel), it can be tricky to guarantee we've recreated this.
+ */
+
+#include <err.h>
+#include <stdio.h>
+#include <sys/types.h>
+#include <ucontext.h>
+#include <stdlib.h>
+
+int
+main(void)
+{
+	ucontext_t ctx;
+	upad128_t u, *up;
+
+	u._l[0] = 0x1;
+	u._l[1] = 0x2;
+	u._l[2] = 0x3;
+	u._l[3] = 0x4;
+
+	/*
+	 * Load %xmm0 and then lock in the data into the pcb with a call to
+	 * getcontext(2) which will force an FPU save.
+	 */
+	/* BEGIN CSTYLED */
+	__asm__ __volatile__ ("movdqu %0, %%xmm0" : : "m" (u));
+	__asm__ __volatile__ ("fldl %0" : : "m" (u));
+	/* END CSTYLED */
+	if (getcontext(&ctx) != 0) {
+		errx(EXIT_FAILURE, "TEST_FAILED: failed to get initial "
+		    "ucontext");
+	}
+
+	/*
+	 * Attempt to reset the FPU at this point and then call getcontext. The
+	 * fninit is for the x87 part. The vzeroall covers all the higher
+	 * registers and this combined should reset the x87 and xmm regions back
+	 * to 0. It appears that on some Intel processors, the vzeroall is
+	 * required to get the XMM set to not be written out as opposed to just
+	 * doing a pxor or similar.
+	 */
+	/* BEGIN CSTYLED */
+        __asm__ __volatile__ ("fninit" : : :);
+        __asm__ __volatile__ ("vzeroall" : : :);
+	/* END CSTYLED */
+	if (getcontext(&ctx) != 0) {
+		errx(EXIT_FAILURE, "TEST_FAILED: failed to get second "
+		    "ucontext");
+	}
+	up = &ctx.uc_mcontext.fpregs.fp_reg_set.fpchip_state.xmm[0];
+	if (up->_l[0] != 0 || up->_l[1] != 0 || up->_l[2] != 0 ||
+	    up->_l[3] != 0) {
+		errx(EXIT_FAILURE, "TEST FAILED: %%xmm0 was not zero, found: "
+		    "0x%x 0x%x 0x%x 0x%x", up->_l[3], up->_l[2],
+		    up->_l[1], up->_l[0]);
+	}
+
+	(void) printf("TEST PASSED: successfully got zeored %%xmm0\n");
+	return (EXIT_SUCCESS);
+}
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/mdb_xregs.ksh	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,190 @@
+#!/usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2023 Oxide Computer Company
+#
+
+#
+# This test attempts to verify that we can mdb (via libproc / thread_db)
+# and xregs sees the expected extended register set. It also ensures
+# that the same values are visible via a core file from that process at
+# the same point.
+#
+
+unalias -a
+set -o pipefail
+export LANG=C.UTF-8
+
+mx_exit=0
+mx_arg0="$(basename $0)"
+mx_dir="$(dirname $0)"
+mx_data="$mx_dir/data"
+mx_tmpdir="/tmp/mdb_xregs.$$"
+
+typeset -A mx_seed
+mx_seed["32"]=0x12900922
+mx_seed["64"]=0x11900456
+typeset -A mx_hwtype
+mx_hwtype["32"]="$mx_dir/xsu_hwtype.32"
+mx_hwtype["64"]="$mx_dir/xsu_hwtype.64"
+typeset -A mx_setprog
+mx_setprog["32"]="$mx_dir/xregs_set.32"
+mx_setprog["64"]="$mx_dir/xregs_set.64"
+
+warn()
+{
+	typeset msg="$*"
+	echo "TEST FAILED: $msg" >&2
+	mx_exit=1
+}
+
+fatal()
+{
+	typeset msg="$*"
+	[[ -z "$msg" ]] && msg="failed"
+	echo "$mx_arg0: $msg" >&2
+	exit 1
+}
+
+cleanup()
+{
+	[[ -n "$mx_tmpdir" ]] && rm -rf "$mx_tmpdir"
+}
+
+setup()
+{
+	if ! mkdir $mx_tmpdir; then
+		fatal "failed to create temporary directory: $mx_tmpdir"
+	fi
+}
+
+check_file()
+{
+	typeset src="$1"
+	typeset act="$2"
+	typeset desc="$3"
+
+	if [[ ! -f "$act" ]]; then
+		warn "failed to generate $act"
+		return
+	fi
+
+	if ! diff -q $src $act; then
+		diff -u $src $act
+		warn "$desc: $act did not match expected output"
+	else
+		printf "TEST PASSED: %s\n" "$desc"
+	fi
+}
+
+#
+# Run one instance of mdb to grab and get our first pass data files
+# against a real process. We're not really counting on our exit status
+# from mdb here, mostly on whether or not the generated files all exist
+# in the end. We gather data from the generated cores in a separate run.
+#
+run_live_mdb()
+{
+	typeset prog="$1"
+	typeset seed="$2"
+	typeset fpregs="$3"
+	typeset core="$4"
+	typeset coreloc="$5"
+
+	mdb $prog <<EOF
+yield::bp
+::run $seed
+::tmodel lwp
+::fpregs ! cat > $fpregs.lwp
+::tmodel thread
+::fpregs ! cat > $fpregs.thread
+_uberdata::printf "$core.%u" uberdata_t pid ! cat > $coreloc
+::gcore -o $core
+::kill
+\$q
+EOF
+}
+
+#
+# We've been given a core file that matches something we just ran above. We
+# should be able to read the ::fpregs from it and get the exact same data.
+#
+check_core()
+{
+	typeset core="$1"
+	typeset output="$2"
+	typeset check="$3"
+
+	if ! mdb -e "::fpregs ! cat > $output" $core; then
+		warn "mdb failed to get ::fpregs from $core"
+		return
+	fi
+
+	check_file $check $output "extracted core matches"
+}
+
+run_one_isa()
+{
+	typeset isa="$1"
+	typeset target=${mx_setprog[$isa]}
+	typeset hwprog=${mx_hwtype[$isa]}
+	typeset seed=${mx_seed[$isa]}
+	typeset coreloc="$mx_tmpdir/coreloc"
+	typeset fpu_type=
+	typeset corename=
+	typeset fpregs=
+	typeset check=
+
+	if ! fpu_type=$($hwprog 2>/dev/null); then
+		warn "failed to determine $isa-bit FPU type"
+		return
+	fi
+
+	printf "Discovered FPU: %s %s-bit\n" $fpu_type $isa
+	corename="$mx_tmpdir/core.$fpu_type.$isa"
+	fpregs="$mx_tmpdir/fpregs.$fpu_type.$isa"
+	check="$mx_data/mdb_xregs.$fpu_type.$isa"
+
+	run_live_mdb $target $seed $fpregs $corename $coreloc
+	check_file "$check" "$fpregs.lwp" "$isa-bit $fpu_type ::fpregs (lwp)"
+	check_file "$check" "$fpregs.lwp" "$isa-bit $fpu_type ::fpregs (thread)"
+
+	if [[ ! -f "$coreloc" ]]; then
+		warn "missing core file location file, cannot run core tests"
+		return
+	fi
+
+	typeset -i ncores=0
+	for f in $(cat $coreloc); do
+		((ncores++))
+		if [[ ! -f "$f" ]]; then
+			warn "core file location $f is not a file"
+			continue
+		fi
+
+		check_core "$f" "$mx_tmpdir/fpregs.core" $check
+	done
+
+	if ((ncores == 0)); then
+		warn "No core files found!"
+	fi
+}
+
+setup
+trap 'cleanup' EXIT
+
+run_one_isa "32"
+run_one_isa "64"
+
+exit $mx_exit
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/proc_writes.ksh	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,142 @@
+#!/usr/bin/ksh
+#
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2023 Oxide Computer Company
+#
+
+#
+# This shell script is a runner that tries to verify that if we write to
+# a target program's xregs via /proc, that it actualy sees the same
+# register contents that we put in. There are four different pieces to
+# this:
+#
+#  o The 'proc_xregs_set' binaries which sets the registers of the target.
+#    Right now we expect the bitness to match whatever it is running against.
+#  o The 'xregs_dump' binaries which dump the FPU state that they have in a
+#    bespoke format.
+#  o The output data files that we use to try to match what is generated.
+#  o The 'xsu_hwtype' binaries which tell us what data format we should expect.
+#
+# We have to discover what kind of hardware our target is running on and then
+# that allows us to ensure that we can match up the right input and output
+# files. We always run both the 32-bit and 64-bit versions of this; however,
+# because 32-bit programs have access to fewer registers, they have a different
+# data file to match against.
+#
+# We also reprat the process of 'proc_xregs_set' using the fpregs binary
+# instead. That allows us to also verify some of the same behavior, but also
+# pieces of fpregs functionality.
+#
+
+unalias -a
+set -o pipefail
+export LANG=C.UTF-8
+
+pw_exit=0;
+pw_arg0="$(basename $0)"
+pw_dir="$(dirname $0)"
+pw_datadir="$pw_dir/data"
+
+#
+# The starting value is used to determine the way that the regiser contents are
+# set in the target's FPU. If you change this value, the check files must be
+# updated.
+#
+typeset -A pw_start
+pw_start["xregs32"]="0xc120ff06"
+pw_start["xregs64"]="0xfaceecaf"
+pw_start["fpregs32"]="0x20190909"
+pw_start["fpregs64"]="0x28186002"
+
+typeset -A pw_hwtypes
+typeset -A pw_dump
+typeset -A pw_prog
+pw_hwtypes["32"]="$pw_dir/xsu_hwtype.32"
+pw_hwtypes["64"]="$pw_dir/xsu_hwtype.64"
+pw_dump["32"]="$pw_dir/xregs_dump.32"
+pw_dump["64"]="$pw_dir/xregs_dump.64"
+pw_prog["xregs32"]="$pw_dir/proc_xregs_set.32"
+pw_prog["xregs64"]="$pw_dir/proc_xregs_set.64"
+pw_prog["fpregs32"]="$pw_dir/fpregs.32"
+pw_prog["fpregs64"]="$pw_dir/fpregs.64"
+
+#
+# All our victim programs are usually the same here and have a single breakpoint
+# we want. This should become an associative array if this changes in the
+# future.
+#
+pw_bkpt="xsu_getfpu"
+
+warn()
+{
+	typeset msg="$*"
+	echo "TEST FAILED: $msg" >&2
+	pw_exit=1
+}
+
+run_single()
+{
+	typeset prog="$1"
+	typeset arch="$2"
+	typeset comb="$prog$arch"
+	typeset fpu_type=
+	typeset start=${pw_start[$comb]}
+	typeset hwtype=${pw_hwtypes[$arch]}
+	typeset dump=${pw_dump[$arch]}
+	typeset exe=${pw_prog[$comb]}
+	typeset output=
+	typeset check=
+
+	if ! fpu_type=$($hwtype 2>/dev/null); then
+		warn "failed to determine $arch-bit FPU type"
+		return
+	fi
+
+	printf "Discovered FPU: %s %s-bit\n" $fpu_type $arch
+	output="/tmp/$prog.$fpu_type.$arch.$$"
+	check="$pw_datadir/proc_writes.$prog.$fpu_type.$arch"
+
+	if ! [[ -r $check ]]; then
+		warn "missing expected output file $check"
+		return;
+	fi
+
+	printf "Running %s %s %s %s\n" $exe $dump $output $start
+	if ! $exe $dump $output $start $pw_bkpt; then
+		warn "$exe did not execute successfully"
+		rm -f $output
+	fi
+
+	if ! diff -q $check $output; then
+		diff -u $check $output
+		warn "$fpu_type $arch-bit FPU regs did not match expected " \
+		    "output"
+	else
+		printf "TEST PASSED: %s %s-bit FPU regs matched /proc write\n" \
+		    $fpu_type $arch
+	fi
+
+	rm -f $output
+}
+
+run_single xregs 32
+run_single xregs 64
+run_single fpregs 32
+run_single fpregs 64
+
+if (( pw_exit == 0 )); then
+	printf "All tests passed successfully\n"
+fi
+
+exit $pw_exit
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/proc_xregs_set.c	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,103 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * This program pairs with the xregs_dump.32 and xregs_dump.64 program. It's
+ * main purpose is to use /proc to overwrite the FPU contents right before our
+ * target program calls xsu_getfpu().
+ *
+ * To accomplish this we end up using libproc for some mischief via support
+ * routines. In particular we go through the following to logically accomplish
+ * this:
+ *
+ *   o Generate the target FPU contents that we'll write (seeded from the CLI)
+ *   o Explicitly create the process, which will be stopped.
+ *   o Set it to be killed if we die.
+ *   o Find the xsu_getfpu() symbol in the target and set a breakpoint.
+ *   o Resume execution of the process.
+ *   o When the break point hits, use libproc to set the FPU.
+ *   o Delete the breakpoint and resume the process, which will print the FPU
+ *     regs to a designated file.
+ *   o Verify the process successfully terminates and returns 0.
+ *
+ * A critical assumption here is that our hardware support is not going to
+ * change between processes (something that may be mucked around with via
+ * environment variables for rtld).
+ */
+
+#include <err.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <string.h>
+
+#include "xsave_util.h"
+
+static xsu_fpu_t fpu;
+
+int
+main(int argc, char *argv[])
+{
+	uint32_t seed, hwsup;
+	unsigned long ul;
+	char *eptr;
+	prxregset_t *prx;
+	size_t prx_len;
+	xsu_proc_t xp;
+
+	if (argc != 5) {
+		errx(EXIT_FAILURE, "missing args: <prog> <output file> "
+		    "<seed> <func>");
+	}
+
+	errno = 0;
+	ul = strtoul(argv[3], &eptr, 0);
+	if (errno != 0 || *eptr != '\0') {
+		errx(EXIT_FAILURE, "seed value is bad: %s", argv[3]);
+	}
+
+#if defined(_LP64)
+	if (ul > UINT32_MAX) {
+		errx(EXIT_FAILURE, "seed %s, exceeds [0, UINT32_MAX]", argv[3]);
+	}
+#endif
+
+	seed = (uint32_t)ul;
+	hwsup = xsu_hwsupport();
+	xsu_fill(&fpu, hwsup, seed);
+	xsu_fpu_to_xregs(&fpu, hwsup, &prx, &prx_len);
+
+	(void) memset(&xp, 0, sizeof (xsu_proc_t));
+	xp.xp_prog = argv[1];
+	xp.xp_arg = argv[2];
+	xp.xp_object = "a.out";
+	xp.xp_symname = argv[4];
+
+	xsu_proc_bkpt(&xp);
+	/* We know that libc always creates a default thread with id of 1 */
+	if (Plwp_setxregs(xp.xp_proc, 1, prx, prx_len) != 0) {
+		err(EXIT_FAILURE, "failed to set target's xregs");
+	}
+
+	xsu_proc_finish(&xp);
+
+	if (WEXITSTATUS(xp.xp_wait) != EXIT_SUCCESS) {
+		errx(EXIT_FAILURE, "our target process didn't exit non-zero, "
+		    "got %d", WEXITSTATUS(xp.xp_wait));
+	}
+
+	return (EXIT_SUCCESS);
+}
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/setcontext_replace.c	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,66 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * The purpose of this program is to go through and replace all the FPU
+ * registers in the floating point state in a ucontext_t and verify that we see
+ * what we expected here.
+ */
+
+#include <err.h>
+#include <stdlib.h>
+#include <ucontext.h>
+
+#include "xsave_util.h"
+
+xsu_fpu_t to_set, found;
+
+static void
+setcontext_replace_check(uint32_t hwsup)
+{
+	xsu_getfpu(&found, hwsup);
+	if (xsu_same(&to_set, &found, hwsup)) {
+		(void) printf("TEST PASSED: setcontext() correctly wrote FPU "
+		    "contents\n");
+		exit(EXIT_SUCCESS);
+	} else {
+		errx(EXIT_FAILURE, "TEST_FAILED: setcontext() did not write "
+		    "full FPU state");
+	}
+}
+
+int
+main(void)
+{
+	ucontext_t *ctx;
+	uint32_t start = arc4random();
+	uint32_t hwsup = xsu_hwsupport();
+
+	ctx = ucontext_alloc(0);
+	if (ctx == NULL) {
+		err(EXIT_FAILURE, "failed to get allocate ucontext_t");
+	}
+	(void) printf("filling starting at 0x%x\n", start);
+	xsu_fill(&to_set, hwsup, start);
+	if (getcontext_extd(ctx, 0) != 0) {
+		err(EXIT_FAILURE, "failed to get extended context");
+	}
+
+	xsu_overwrite_uctx(ctx, &to_set, hwsup);
+	makecontext(ctx, setcontext_replace_check, 1, hwsup);
+	(void) setcontext(ctx);
+
+	err(EXIT_FAILURE, "TEST FAILED: set context did not work!");
+}
--- /dev/null	Wed Apr 12 20:33:29 2023
+++ new/usr/src/test/os-tests/tests/xsave/setcontext_restore.c	Wed Apr 12 20:33:29 2023
@@ -0,0 +1,75 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * This test goes through and verifies that the FPU contents are properly
+ * restored with a setcontext call.
+ */
+
+#include <err.h>
+#include <stdlib.h>
+#include <ucontext.h>
+#include <limits.h>
+
+#include "xsave_util.h"
+
+xsu_fpu_t init_set, override, found;
+volatile int exit_status = EXIT_SUCCESS;
+
+static void
+setcontext_restore_check(uint32_t hwsup)
+{
+	xsu_getfpu(&found, hwsup);
+	if (xsu_same(&init_set, &found, hwsup)) {
+		(void) printf("TEST PASSED: setcontext() correctly restored "
+		    "clobbered FPU contents\n");
+		exit(exit_status);
+	} else {
+		errx(EXIT_FAILURE, "TEST_FAILED: setcontext() did not properly "
+		    "restore clobbered FPU contents");
+	}
+}
+
+int
+main(void)
+{
+	ucontext_t *ctx;
+	uint32_t start = arc4random();
+	uint32_t hwsup = xsu_hwsupport();
+
+	ctx = ucontext_alloc(0);
+	if (ctx == NULL) {
+		err(EXIT_FAILURE, "failed to get allocate ucontext_t");
+	}
+	(void) printf("filling starting at 0x%x\n", start);
+	xsu_fill(&init_set, hwsup, start);
+	xsu_fill(&override, hwsup, start + INT_MAX);
+	xsu_setfpu(&init_set, hwsup);
+
+	if (getcontext_extd(ctx, 0) != 0) {
+		err(EXIT_FAILURE, "failed to get extended context");
+	}
+
+	makecontext(ctx, setcontext_restore_check, 1, hwsup);
+	xsu_setfpu(&override, hwsup);
+	xsu_getfpu(&found, hwsup);
+	if (!xsu_same(&override, &found, hwsup)) {
+		warnx("TEST FAILED: override FPU data not found!");
+		exit_status = EXIT_FAILURE;
+	}
+	(void) setcontext(ctx);
+
+	err(EXIT_FAILURE, "TEST FAILED: set context did not work!");
+}
